org.mariadb.jdbc.internal.mysql

## Interface Protocol

All Known Implementing Classes:
  AuroraProtocol, MastersSlavesProtocol, MySQLProtocol

    public interface Protocol

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `cancelCurrentQuery()`
`boolean` `checkIfMaster()`
`void` `close()`
`void` `closeExplicit()`
`void` `closeIfActiveResult()`
`void` `closePreparedStatement(int statementId)`
`void` `connect()`
`void` `connectWithoutProxy()`
`QueryResult` `executePreparedQuery(String sql, ParameterHolder[] parameters, PrepareResult prepareResult, MySQLType[] parameterTypeHeader, boolean isStreaming)`
`QueryResult` `executePreparedQueryAfterFailover(String sql, ParameterHolder[] parameters, PrepareResult oldPrepareResult, MySQLType[] parameterTypeHeader, boolean isStreaming)`
`QueryResult` `executeQuery(List<Query> dQueries, boolean streaming, boolean isRewritable, int rewriteOffset)`
`QueryResult` `executeQuery(Query dQuery)`
`QueryResult` `executeQuery(Query dQuery, boolean streaming)`
`boolean` `getAutocommit()`
`Calendar` `getCalendar()`
`String` `getDatabase()`
`int` `getDatatypeMappingFlags()`
`String` `getHost()`
`HostAddress` `getHostAddress()`
`JDBCUrl` `getJdbcUrl()`
`int` `getMajorServerVersion()`
`int` `getMaxRows()`
`int` `getMinorServerVersion()`
`QueryResult` `getMoreResults(boolean streaming)`
`Options` `getOptions()`
`String` `getPassword()`
`boolean` `getPinGlobalTxToPhysicalConnection()`
`int` `getPort()`
`FailoverProxy` `getProxy()`
`boolean` `getReadonly()`
`QueryResult` `getResult(Object dQuery, boolean streaming, boolean binaryProtocol)`
`String` `getServerData(String code)`
`long` `getServerThreadId()`
`String` `getServerVersion()`
`int` `getTimeout()`
`int` `getTransactionIsolationLevel()`
`String` `getUsername()`
`boolean` `hasMoreResults()`
`boolean` `hasUnreadData()`
`boolean` `hasWarnings()`
`boolean` `inTransaction()`
`boolean` `isClosed()`
`boolean` `isConnected()`
`boolean` `isExplicitClosed()`
`boolean` `isMasterConnection()`
`boolean` `mustBeMasterConnection()`
`boolean` `noBackslashEscapes()`
`boolean` `ping()`
`PrepareResult` `prepare(String sql)`
`PrepareStatementCache` `prepareStatementCache()`
`void` `releasePrepareStatement(String sql, int statementId)`
`void` `rollback()`
`void` `setCatalog(String database)`
`void` `setHostAddress(HostAddress hostAddress)`
`void` `setHostFailedWithoutProxy()`
`void` `setInternalMaxRows(int max)`
`void` `setLocalInfileInputStream(InputStream inputStream)`
`void` `setMaxRows(int max)`
`void` `setProxy(FailoverProxy proxy)`
`void` `setReadonly(boolean readOnly)`
`void` `setTimeout(int timeout)`
`void` `setTransactionIsolation(int level)`
`boolean` `shouldReconnectWithoutProxy()`
`boolean` `versionGreaterOrEqual(int major, int minor, int patch)`

### Method Detail

#### prepare

    PrepareResult prepare(String sql)
                   throws QueryException

Throws:
  `QueryException`

#### closePreparedStatement

    void closePreparedStatement(int statementId)
                         throws QueryException

Throws:
  `QueryException`

#### getAutocommit

    boolean getAutocommit()

#### noBackslashEscapes

    boolean noBackslashEscapes()
                        throws QueryException

Throws:
  `QueryException`

#### connect

    void connect()
          throws QueryException

Throws:
  `QueryException`

#### getJdbcUrl

    JDBCUrl getJdbcUrl()

#### inTransaction

    boolean inTransaction()

#### getProxy

    FailoverProxy getProxy()

#### setProxy

    void setProxy(FailoverProxy proxy)

#### getOptions

    Options getOptions()

#### hasMoreResults

    boolean hasMoreResults()

#### close

    void close()

#### closeExplicit

    void closeExplicit()

#### isClosed

    boolean isClosed()

#### setCatalog

    void setCatalog(String database)
             throws QueryException

Throws:
  `QueryException`

#### getServerVersion

    String getServerVersion()

#### isConnected

    boolean isConnected()

#### getReadonly

    boolean getReadonly()

#### setReadonly

    void setReadonly(boolean readOnly)
              throws QueryException

Throws:
  `QueryException`

#### isMasterConnection

    boolean isMasterConnection()

#### mustBeMasterConnection

    boolean mustBeMasterConnection()

#### getHostAddress

    HostAddress getHostAddress()

#### setHostAddress

    void setHostAddress(HostAddress hostAddress)

#### getHost

    String getHost()

#### getPort

    int getPort()

#### rollback

    void rollback()

#### getDatabase

    String getDatabase()

#### getUsername

    String getUsername()

#### getPassword

    String getPassword()

#### ping

    boolean ping()
          throws QueryException

Throws:
  `QueryException`

#### executeQuery

    QueryResult executeQuery(Query dQuery)
                      throws QueryException

Throws:
  `QueryException`

#### executeQuery

    QueryResult executeQuery(List<Query> dQueries,
                             boolean streaming,
                             boolean isRewritable,
                             int rewriteOffset)
                      throws QueryException

Throws:
  `QueryException`

#### getResult

    QueryResult getResult(Object dQuery,
                          boolean streaming,
                          boolean binaryProtocol)
                   throws QueryException

Throws:
  `QueryException`

#### executeQuery

    QueryResult executeQuery(Query dQuery,
                             boolean streaming)
                      throws QueryException

Throws:
  `QueryException`

#### cancelCurrentQuery

    void cancelCurrentQuery()
                     throws QueryException,
                            IOException

Throws:
  `QueryException`
  `IOException`

#### getMoreResults

    QueryResult getMoreResults(boolean streaming)
                        throws QueryException

Throws:
  `QueryException`

#### hasUnreadData

    boolean hasUnreadData()

#### checkIfMaster

    boolean checkIfMaster()
                   throws QueryException

Throws:
  `QueryException`

#### hasWarnings

    boolean hasWarnings()

#### getDatatypeMappingFlags

    int getDatatypeMappingFlags()

#### setInternalMaxRows

    void setInternalMaxRows(int max)

#### getMaxRows

    int getMaxRows()

#### setMaxRows

    void setMaxRows(int max)
             throws QueryException

Throws:
  `QueryException`

#### getMajorServerVersion

    int getMajorServerVersion()

#### getMinorServerVersion

    int getMinorServerVersion()

#### versionGreaterOrEqual

    boolean versionGreaterOrEqual(int major,
                                  int minor,
                                  int patch)

#### setLocalInfileInputStream

    void setLocalInfileInputStream(InputStream inputStream)

#### getTimeout

    int getTimeout()
            throws SocketException

Throws:
  `SocketException`

#### setTimeout

    void setTimeout(int timeout)
             throws SocketException

Throws:
  `SocketException`

#### getPinGlobalTxToPhysicalConnection

    boolean getPinGlobalTxToPhysicalConnection()

#### getServerThreadId

    long getServerThreadId()

#### setTransactionIsolation

    void setTransactionIsolation(int level)
                          throws QueryException

Throws:
  `QueryException`

#### getTransactionIsolationLevel

    int getTransactionIsolationLevel()

#### isExplicitClosed

    boolean isExplicitClosed()

#### closeIfActiveResult

    void closeIfActiveResult()

#### connectWithoutProxy

    void connectWithoutProxy()
                      throws QueryException

Throws:
  `QueryException`

#### shouldReconnectWithoutProxy

    boolean shouldReconnectWithoutProxy()

#### setHostFailedWithoutProxy

    void setHostFailedWithoutProxy()

#### executePreparedQuery

    QueryResult executePreparedQuery(String sql,
                                     ParameterHolder[] parameters,
                                     PrepareResult prepareResult,
                                     MySQLType[] parameterTypeHeader,
                                     boolean isStreaming)
                              throws QueryException

Throws:
  `QueryException`

#### releasePrepareStatement

    void releasePrepareStatement(String sql,
                                 int statementId)
                          throws QueryException

Throws:
  `QueryException`

#### executePreparedQueryAfterFailover

    QueryResult executePreparedQueryAfterFailover(String sql,
                                                  ParameterHolder[] parameters,
                                                  PrepareResult oldPrepareResult,
                                                  MySQLType[] parameterTypeHeader,
                                                  boolean isStreaming)
                                           throws QueryException

Throws:
  `QueryException`

#### prepareStatementCache

    PrepareStatementCache prepareStatementCache()

#### getServerData

    String getServerData(String code)

#### getCalendar

    Calendar getCalendar()